searchNodes=[{"ref":"JUnitFormatter.html","title":"JUnitFormatter","type":"module","doc":"A ExUnit.Formatter implementation that generates a xml in the format understood by JUnit. To acomplish this, there are some mappings that are not straight one to one. Therefore, here goes the mapping: JUnit - ExUnit Testsuites - :testsuite Testsuite - %ExUnit.TestCase{} failures = failures skipped = skip errors = invalid time = (sum of all times in seconds rounded down) Testcase - %ExUnit.Test name = :case test = :test content (only if not successful) skipped = {:state, {:skip, _}} failed = {:state, {:failed, {_, reason, stacktrace}}} reason = reason.message contet = Exception.format_stacktrace(stacktrace) error = {:invalid, module} The report is written to a file in the _build directory."},{"ref":"JUnitFormatter.html#child_spec/1","title":"JUnitFormatter.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"JUnitFormatter.html#format_time/1","title":"JUnitFormatter.format_time/1","type":"function","doc":"Formats time from nanos to seconds"},{"ref":"JUnitFormatter.html#get_report_file_path/0","title":"JUnitFormatter.get_report_file_path/0","type":"function","doc":"Helper function to get the full path of the generated report file. It can be passed 2 configurations report_dir: full path of a directory (defaults to Mix.Project.app_path()) report_file: name of the generated file (defaults to &quot;test-junit-report.xml&quot;)"},{"ref":"JUnitFormatter.Stats.html","title":"JUnitFormatter.Stats","type":"module","doc":"A struct to keep track of test values and tests themselves. It is used to build the testsuite junit node."},{"ref":"JUnitFormatter.Stats.html#t:t/0","title":"JUnitFormatter.Stats.t/0","type":"type","doc":""},{"ref":"readme.html","title":"Overview","type":"extras","doc":"JUnitFormatter A simple ExUnit Formatter that collects test results and generates an xml report in JUnit format. This is intended to be used by tools that can produce a graphical report, mainly targeted at Jenkins and its support for JUnit. The report is generated in Mix.Project.app_path folder with a default filename of test-junit-report.xml. It can be configured through application configuration on the key report_file (application junit_formatter). Versions 3+ require minimum Elixir version to be 1.5+. For older releases, please use version 2.2 of this library."},{"ref":"readme.html#usage","title":"Overview - Usage","type":"extras","doc":"First, add JUnitFormatter to the dependencies in your mix.exs: defp deps do [ {:junit_formatter, &quot;~&gt; 3.1&quot;, only: [:test]} ] end Next, add JUnitFormatter to your ExUnit configuration in test/test_helper.exs file. It should look like this: ExUnit.configure formatters: [JUnitFormatter] ExUnit.start If you want to keep using the default formatter alongside the JUnitFormatter your test/test_helper.exs file should look like this: ExUnit.configure formatters: [JUnitFormatter, ExUnit.CLIFormatter] ExUnit.start Then run your tests like normal: .... Finished in 0.1 seconds (0.07s on load, 0.08s on tests) 4 tests, 0 failures Randomized with seed 600810 The JUnit style XML report for this project looks like this: &lt;?xml version=&quot;1.0&quot;?&gt; &lt;testsuites&gt; &lt;testsuite errors=&quot;0&quot; failures=&quot;0&quot; name=&quot;Elixir.FormatterTest&quot; tests=&quot;4&quot; time=&quot;82086&quot;&gt; &lt;testcase classname=&quot;Elixir.FormatterTest&quot; name=&quot;test it counts raises as failures&quot; time=&quot;16805&quot;/&gt; &lt;testcase classname=&quot;Elixir.FormatterTest&quot; name=&quot;test that an invalid test generates a proper report&quot; time=&quot;16463&quot;/&gt; &lt;testcase classname=&quot;Elixir.FormatterTest&quot; name=&quot;test that a valid test generates a proper report&quot; time=&quot;16328&quot;/&gt; &lt;testcase classname=&quot;Elixir.FormatterTest&quot; name=&quot;test valid and invalid tests generates a proper report&quot; time=&quot;32490&quot;/&gt; &lt;/testsuite&gt; &lt;/testsuites&gt; note: this example has been reformatted for readability."},{"ref":"readme.html#options","title":"Overview - Options","type":"extras","doc":"JUnitFormatter accepts 4 options that can be passed in config.exs (or equivalent environment configuration for tests): print_report_file (boolean - default false): tells formatter if you want to see the path where the file is being written to in the console. This might help you debug where the file is. By default it writes the report to the Mix.Project.app_path folder. This ensures compatibility with umbrella apps. report_file (binary - default &quot;test-junit-report.xml&quot;): the name of the file to write to. It must contain the extension. 99% of the time you will want the extension to be .xml, but if you don&#39;t you can pass any extension (though the contents of the file will be an xml document). report_dir (binary - default Mix.Project.app_path()): the directory to which the formatter will write the report. Do not end it with a slash. IMPORTANT!! JUnitFormatter will NOT create the directory. If you are pointing to a directory that is outside _build then it is your duty to clean it and to be sure it exists. prepend_project_name? (boolean - default false): tells if the report file should have the name of the project as a prefix. See the &quot;Umbrella&quot; part of the documentation. include_filename? (boolean - default false): dictates whether &lt;testcase&gt;s in the XML report should include a &quot;file&quot; attribute of the relative path to the file of the test. Note that this defaults to false because not all JUnit ingesters will accept a file attribute. Example configuration: config :junit_formatter, report_file: &quot;report_file_test.xml&quot;, report_dir: &quot;/tmp&quot;, print_report_file: true, prepend_project_name?: true, include_filename?: true This would generate the report at: /tmp/myapp-report_file_test.xml."},{"ref":"readme.html#umbrella-projects","title":"Overview - Umbrella projects","type":"extras","doc":"JUnitFormatter works with umbrella projects too. By default, it will generate the xml report on each sub-project build folder. So, as an example, if you have two apps (my-app and another) it will generate the following reports: _build/test/lib/my_app/report_file.xml _build/test/lib/another/report_file.xml This works without any extra configuration. There are times, though, where you want to customize the directory where the reports are generated. Let&#39;s say you add this configuration: config :junit_formatter, report_dir: &quot;/tmp&quot; Then, while running in an umbrela project, the first sub-project will run and generate a report file the following path: /tmp/report_file.xml The next one will do the same OVERRIDING the first one. So, in order to avoid this, you can use the configuration option prepend_project_name? so that the result would be: /tmp/my_app-report_file.xml /tmp/another-report_file.xml"},{"ref":"readme.html#integrating-on-ci-systems","title":"Overview - Integrating on CI systems","type":"extras","doc":"Most CIs have a way for uploading test reports. This is a nice way to understand what failed on your build. Most of them use the JUnit report file format to provide this feature. CircleCI example configuration provides JUnit reports integration"},{"ref":"readme.html#license","title":"Overview - LICENSE","type":"extras","doc":"This project is available under Apache Public License version 2.0. See LICENSE."},{"ref":"changelog.html","title":"Changelog","type":"extras","doc":"Changelog"},{"ref":"changelog.html#3-1-0-2020-03-14","title":"Changelog - [3.1.0] - 2020-03-14","type":"extras","doc":"Added If include_filename? attribute is true, add the relative path from … (#37 thanks to @danadaldos)"},{"ref":"changelog.html#3-0-1-2019-07-11","title":"Changelog - [3.0.1] - 2019-07-11","type":"extras","doc":"Fixed Converts String to utf8 charlist, instead of unicode (#34 thank to @mrmstn)"},{"ref":"changelog.html#3-0-0","title":"Changelog - 3.0.0","type":"extras","doc":"Breaking: JUnitFormatter now supports only Elixir 1.5+. If you need support for older versions, please use version 2.x. Added: Error messages now retain their whole format from standard ExUnit formatter (thanks to @hauleth) Refactored the tests to use xpath (thanks to @hauleth) Refactored the code base to be more modern (thanks to @hauleth) Bugfixes: Fixed options description in README Better CI integration: Credo, test tracing Updated deps (and docs)"},{"ref":"changelog.html#2-2-0","title":"Changelog - 2.2.0","type":"extras","doc":"Bugfixes: Fix unicode characters in test names on OTP 20. It is important to notice that test names with unicode characters that are not ascii will ONLY work if running on OTP 20. Thanks to @sparta-developers Add option of prepending the project name to the report file to avoid overriding the results when in umbrella project. README was also updated. Thanks to @axelson for bringing the issue."},{"ref":"changelog.html#2-1-0","title":"Changelog - 2.1.0","type":"extras","doc":"Bugfixes: Fixes subprocess crashes. When a subprocess crashes it sends a {:EXIT, pid} message that can&#39;t be parsed by Atom.to_string/1. Thanks to @dmt ! Fixes running tests on Elixir 1.6.0-rc.0. ExUnit.Server.cases_loaded() got renamed to ExUnit.Server.modules_loaded()."},{"ref":"changelog.html#2-0-0","title":"Changelog - 2.0.0","type":"extras","doc":"Backwards incompatible: This release raises the minimum Elixir version to 1.4. This is due to GenEvent handlers for ExUnit.Formatter being deprecated in Elixir 1.4."},{"ref":"changelog.html#v1-3-0","title":"Changelog - v1.3.0","type":"extras","doc":"Bugfixes: Handle errors that have a message with value nil properly. Thanks to @PierrePIRONIN. Fixed Elixir 1.4+ warnings. Thanks to @jwfearn. Improved test coverage (added skip tests)."},{"ref":"changelog.html#v1-2-0","title":"Changelog - v1.2.0","type":"extras","doc":"Backwards incompatible: This release raises the minimum Elixir version to 1.1 and is only tested with Erlang 18 and above. Features: Added config property report_dir. This makes it possible to set absolute paths for the generated reports. Added helper function JUnitFormatter.get_report_file_path/0 that returns the final path of the report with the applied defaults and configurations."},{"ref":"changelog.html#v1-1-0","title":"Changelog - v1.1.0","type":"extras","doc":"Backwards incompatible: This release has changed the location where the report is written to. Features: Changed implementation of logging report file location to use Logger. This is meant to be more helpful in configuring since it can be disabled in Logger level. Bugfixes: Support for umbrella projects. Reports are written to Mix.Project.app_path instead of Mix.Project.build_path."},{"ref":"changelog.html#v1-0-0","title":"Changelog - v1.0.0","type":"extras","doc":"Features: ExUnit.Formatter implementation that prints an xml to the build directory. Bugfixes: Correctly show time of testsuite in seconds rather than micro seconds (thanks to @ibizaman) Correctly handle errors with empty messages (thanks to @Reimerei) Fixed name of failed tests tag in xml (thanks to @KronicDeth) Fixed compatibility with Elixir 1.2 (thanks to @adrienmo)"}]